<?php
class lineaActions extends wtActions
{
    public function executeIndex()
    {
        
    }
    
    public function executeList()
    {
        LayoutTemplate::getInstance()->setUseBootstrap();
    	$this->block = $this->getRequestParameter( 'block' );
    }
    
    public function executeGrid()
    {
       
        $block = $this->getRequestParameter( 'block' );
        $page  = $this->getRequestParameter( 'page' );
        
         set_header_utf8();
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $o_GridAction = new GridAction();
        $o_GridAction->setClassFind( new MST_ClaseLineaFN() );
        
        $o_GridAction->addConditionFilter( "Descripcion", MST_ClaseLineaFN::Descripcion, "LIKE", "%%s%" );
        
        $o_GridAction->addOrder( "Descripcion", MST_ClaseLineaFN::Descripcion);
        $o_GridAction->addOrder( "Estado", MST_ClaseLineaFN::Estado );
        
        $o_GridAction->addOrderDefault( MST_ClaseLineaFN::IdLinea , true );
        
        $o_GridAction->addRowsToShow( "IdLinea", "Codigo", "Descripcion", "Estado" );
        
        $o_GridAction->setNumberRecordsShow( 15 );
        
        $o_GridAction->initialize();
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $a_ResultJson['page']    = $o_GridAction->getPage();
        $a_ResultJson['total']   = $o_GridAction->getTotalPage();
        $a_ResultJson['records'] = $o_GridAction->getTotalRecords();
        $a_ResultJson['rows']    = $o_GridAction->getResultArray();
        //pr( $a_ResultJson );
        echo json_encode( $a_ResultJson );

        return ViewResponse::NONE;   
    }

    public function executeAddedit()
    {
        LayoutTemplate::getInstance()->setUseBootstrap();
        $this->block      = $this->getRequestParameter( 'block' );
        $this->i_Id       = $this->getRequestParameter( 'i_Id' );
        $this->s_TipoProc = $this->getRequestParameter( 's_TipoProc' );
        
                
        $this->s_Titulo = "Nuevo Linea";
        $o_MST_ClaseLineaBN = new MST_ClaseLineaBN();
        $o_MST_ClaseLineaBN->setEstado('A');
        $this->o_MST_ClaseLineaBN = $o_MST_ClaseLineaBN;
        if( $this->s_TipoProc == "upd" )
        {
            $this->s_Titulo = "Editar Linea";
            $o_MST_ClaseLineaFN = new MST_ClaseLineaFN();
            $this->o_MST_ClaseLineaBN = $o_MST_ClaseLineaFN->selectByPK( $this->i_Id );
        }
    }
   
    public function executeSaveAddEdit()
    {
        $block      = $this->getRequestParameter( 'block' );
        $i_Id       = $this->getRequestParameter( 'i_Id' );
        $s_TipoProc = $this->getRequestParameter( 's_TipoProc' );
        $TypeSub    = $this->getRequestParameter( 'TypeSub' );
        
        
        
        $Descripcion = trim( $this->getRequestParameter( 'Descripcion' ) );
        $Codigo      = $this->getRequestParameter( 'Codigo' );
        $Estado      = $this->getRequestParameter( 'Estado' );
        try 
        {
            $o_MST_ClaseLineaDP = new MST_ClaseLineaDP();
            
            $o_MST_ClaseLineaDP->setDescripcion( trim( $Descripcion ) );
            $o_MST_ClaseLineaDP->setEstado( $Estado );
            if( $s_TipoProc == "nvo" )
            {
                //NUEVO
                $IdLinea = MST_ClaseLineaFN::recuperarId();

                $Codigo = substr( $Descripcion, 0, 3 ).$IdLinea;
                $o_MST_ClaseLineaDP->setCodigo( $Codigo );
                
                $o_MST_ClaseLineaDP->setIdLinea( $IdLinea );
                $o_MST_ClaseLineaDP->setFechaCreacion( date( "Y-m-d H:i:s" ) );
                $o_MST_ClaseLineaDP->setUsuarioCreacion( myUser::getUser()->getUserId() );
                $o_MST_ClaseLineaDP->setFechaModificacion( date( "Y-m-d H:i:s" ) );
                $o_MST_ClaseLineaDP->setUsuarioModificacion( myUser::getUser()->getUserId() );
                $b_Result = $o_MST_ClaseLineaDP->save();
                $i_Id = $IdLinea;
            }
            else 
            {
                //UPDATE
                 $i_Id = ( int ) $this->getRequestParameter( 'i_Id' );
                $o_MST_ClaseLineaDP->setIdLinea( $i_Id );
                $o_MST_ClaseLineaDP->setFechaModificacion( date( "Y-m-d H:i:s" ) );
                $o_MST_ClaseLineaDP->setUsuarioModificacion( myUser::getUser()->getUserId() );
                $b_Result = $o_MST_ClaseLineaDP->update();
            }
            $a_Rs['type_sub'] = $TypeSub;
            $a_Rs['error']    = false;
            $a_Rs['id']       = $i_Id;
        }
        catch ( Exception $o_Exception )
        {
            $a_Rs['error']         = true;
            $a_Rs['mensaje_error'] = $o_Exception->getMessage();
        }
        echo json_encode( $a_Rs );
        return ViewResponse::NONE;
    }
    
    public function executeAudi()
    {
        $block          = $this->getRequestParameter( 'block' );
        $i_Id           = $this->getRequestParameter( 'i_Id' );
        $this->s_Topico = "Linea";
        $o_MST_ClaseLineaFN = new MST_ClaseLineaFN();
        $this->o_ObjectBN = $o_MST_ClaseLineaFN->selectByPK( $i_Id );
    }
    
    public function executeViewdel()
    {
        $this->block      = $this->getRequestParameter( 'block' );
        $this->i_Id       = $this->getRequestParameter( 'i_Id' );
        $this->s_TipoProc = $this->getRequestParameter( 's_TipoProc' );
       
        
        $o_MST_ClaseLineaFN = new MST_ClaseLineaFN();
        $this->o_MST_ClaseLineaBN = $o_MST_ClaseLineaFN->selectByPK( $this->i_Id );
    }
    
    public function executeDeleteRow()
    {
        $block      = $this->getRequestParameter( 'block' );
        $i_Id       = $this->getRequestParameter( 'i_Id' );
        $s_TipoProc = $this->getRequestParameter( 's_TipoProc' );
        
        try 
        {
        	
            $o_MST_ClaseLineaDP = new MST_ClaseLineaDP();
            $o_MST_ClaseLineaDP->setIdLinea( ( int )$i_Id );
            $o_MST_ClaseLineaDP->setEstado( "I" );
            $o_MST_ClaseLineaDP->setFechaModificacion( date( "Y-m-d H:i:s" ) );
            $o_MST_ClaseLineaDP->setUsuarioModificacion( myUser::getUser()->getUserId() );
            $o_MST_ClaseLineaDP->update();

            $a_Rs['error']   = false;
            $a_Rs['id']      = $i_Id;
        }
        catch ( Exception $o_Exception )
        {
            $a_Rs['error']   = true;
            $a_Rs['mensaje_error_ex'] = $o_Exception->getMessage();
            $a_Rs['mensaje_error'] = "No se pudo eliminar el registro.";
        }
        echo json_encode( $a_Rs );
        return ViewResponse::NONE;
    }
}